/**
 * Copyright © VNG Realisatie 2023
 * Licensed under the EUPL
 */

@use "../theme";
@use "./button";

label {
    display: block;
    width: max-content;
    margin-bottom: theme.$spacing01;
    margin-top: theme.$spacing06;
    word-break: keep-all;
    color: theme.$colorTextInputLabel;
    cursor: pointer;

    span {
        display: block;
    }
}

fieldset {
    padding: 0 0 3rem 0;
    border: 0 none;
}

legend {
    margin: 0;
    font-weight: theme.$fontWeightBold;
    font-size: theme.$fontSizeLarge;
    line-height: theme.$lineHeightHeading;
}

input,
.input {
    display: block;
    padding: theme.$spacing04;
    border: 1px solid theme.$colorBorderInput;
    margin-top: theme.$spacing01;
    outline: none;
    font-size: theme.$fontSizeMedium;
    font-family: 'Source Sans Pro', sans-serif;
    line-height: theme.$lineHeightText;
    color: theme.$colorTextInputLabel;
    background-color: theme.$colorBackgroundInput;
    width: 100%;

    ::placeholder,
    ::-webkit-input-placeholder,
    :-ms-input-placeholder {
        color: theme.$colorTextInputPlaceholder;
    }

    &:focus,
    &--invalid {
        padding: calc(#{theme.$spacing04} - 1px);
        border: 2px solid theme.$colorBorderInputFocus;
    }

    &--invalid {
        border-color: theme.$colorBorderInputError;
    }

    &[disabled],
    &[readonly] {
        background-color: theme.$colorBackgroundInputDisabled;
        border-color: theme.$colorBorderInputDisabled;
        cursor: not-allowed;
        color: theme.$colorTextInputDisabled;
    }

    &--xs { width: 5rem }
    &--small { width: 10rem }
    &--medium { width: 20rem }
    &--large { width: 30rem }
    &--xl { width: 46rem }
}

.select {
    margin-top: 0.125rem;
    position: relative;
    width: 20rem;
    color: theme.$colorText;

    &:after {
        content: "";
        background: url(/img/icon-chevron-down.svg) no-repeat center;
        border-left: 1px solid theme.$colorPaletteGray300;
        width: 2.5rem;
        height: 1.5rem;
        position: absolute;
        pointer-events: none;
        top: calc(50% - .75rem);
        bottom: 0;
        right: theme.$spacing02;
    }

    select::-ms-expand {
        display: none;
    }

    select {
        appearance: none;
        padding: theme.$spacing04 theme.$spacing09 theme.$spacing04 theme.$spacing04;
        text-overflow: ellipsis;
        border: 1px solid theme.$colorBorderSelect;
        outline: none;
        font-size: theme.$fontSizeMedium;
        font-family: 'Source Sans Pro', sans-serif;
        line-height: theme.$lineHeightText;
        width: 100%;
        align-items: center;
        cursor: default;
        display: flex;
        flex-wrap: wrap;
        justify-content: space-between;
        min-height: 38px;
        outline: 0 !important;
        position: relative;
        transition: all 100ms ease 0s;
        box-sizing: border-box;
        border-radius: 0;
        background-color: theme.$colorBackgroundSelect;
        color: theme.$colorText;
        margin: 0;
    }
}

.datalist {
    margin-top: 0.125rem;
    position: relative;
    width: 20rem;
    color: theme.$colorText;

    input {
        cursor: pointer;
    }

    &:after {
        content: "";
        background: url(/img/icon-chevron-down.svg) no-repeat center;
        border-left: 1px solid theme.$colorPaletteGray300;
        width: 2.5rem;
        height: 1.5rem;
        position: absolute;
        pointer-events: none;
        top: calc(50% - .75rem);
        bottom: 0;
        right: theme.$spacing02;
    }

    input {
        padding: theme.$spacing04 theme.$spacing09 theme.$spacing04 theme.$spacing04;
        text-overflow: ellipsis;
        border: 1px solid theme.$colorBorderSelect;
        outline: none;
        font-size: theme.$fontSizeMedium;
        font-family: 'Source Sans Pro', sans-serif;
        line-height: theme.$lineHeightText;
        width: 100%;
        align-items: center;
        display: flex;
        flex-wrap: wrap;
        justify-content: space-between;
        min-height: 38px;
        outline: 0 !important;
        position: relative;
        transition: all 100ms ease 0s;
        box-sizing: border-box;
        border-radius: 0;
        background-color: theme.$colorBackgroundSelect;
        color: theme.$colorText;
        margin: 0;
        overflow: hidden;
    }

    &--xs { width: 5rem }
    &--small { width: 10rem }
    &--medium { width: 20rem }
    &--large { width: 30rem }
    &--xl { width: 46rem }
}


.invalid-feedback {
    font-weight: theme.$fontWeightBold;
    color: theme.$colorError;
    margin: theme.$spacing03 0 theme.$spacing06 0;
}

.checkbox {
    display: inline-flex;
    line-height: 1rem;
    margin-right: theme.$spacing08;
    cursor: pointer;

    input {
        margin-right: theme.$spacing04;
        appearance: none;
        width: 1rem;
        height: 1rem;
        vertical-align: middle;
        cursor: pointer;
        padding: 0px;
        box-sizing: border-box;

        &:not(:checked) {
            border: 1px solid theme.$colorBorderChoice;
        }

        &:checked {
            background-color: theme.$colorBackgroundChoiceSelected;
            background-image: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciIHZpZXdCb3g9IjAgMCAxOCAxOCIgZmlsbD0iIzIxMjEyMSI+PHBvbHlnb24gcG9pbnRzPSI3LjI0MyAxMy40ODUgMyA5LjI0MiA0LjQxNCA3LjgyOCA3LjI0MyAxMC42NTcgMTIuODk5IDUgMTQuMzE0IDYuNDE0Ij48L3BvbHlnb24+PC9zdmc+);
        }

        &:focus {
            border: 1px solid theme.$colorBorderChoiceFocus;
            outline: 1px solid theme.$colorBorderChoiceFocus;
        }
    }
}
